EricYang

Tech Spot of Eric

  博客园 :: 首页 :: 博问 :: 闪存 :: 新随笔 :: 联系 :: 订阅 订阅 :: 管理 ::

Prime Path

Time Limit: 1000MS Memory Limit: 65536K
Total Submissions: 5585 Accepted: 3219

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0

Source


BFS:在10000内素数中,找改变一位路径到另个目标素数。
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <queue>

using namespace std;

typedef struct node
{
    int i;
    int step;
}Node;

queue<Node> p_q;
bool visit[10000];
bool isPrime[10000];

bool getPrime(int n)
{
    int i;

    if (n==1)
        return 0;
    if (n==2)
        return 1;
    else
    {
        for(i=2;i<=sqrt(n);i++)
            if (n%i==0)
                return 0;
        return 1;

    }
}

int main()
{
    Node source, goal;
    int t;
    Node temp, temp1;
    char digits[5];
    bool isFind;

    memset(isPrime,0,sizeof(isPrime));
    for(int i=1; i<=9999; i++)
    {
        if(getPrime(i))
            isPrime[i]=true;
    }
    scanf("%d",&t);
    while(t--)
    {
        memset(visit,0,sizeof(visit));
        scanf("%d%d",&source.i,&goal.i);
        //BFS
        isFind=false;
        source.step=0;
        p_q.push(source);
        visit[source.i]=true;
        while(!p_q.empty())
        {
            temp=p_q.front();
            p_q.pop();
            if(temp.i==goal.i)
            {
                printf("%d\n",temp.step);
                isFind=true;
                break;
            }
            sprintf(digits,"%d",temp.i); // change int to char*
            for(int weight=0; weight<=3; weight++)
            {
                for(int i=0; i<=9; i++)
                {
                    if(weight==0 && i==0) //0XXX
                         continue;
                    if(weight==0)
                        temp1.i=i*1000+(digits[1]-'0')*100+(digits[2]-'0')*10+(digits[3]-'0');
                    else if(weight==1)
                        temp1.i=(digits[0]-'0')*1000+i*100+(digits[2]-'0')*10+(digits[3]-'0');
                    else if(weight==2)
                        temp1.i=(digits[0]-'0')*1000+(digits[1]-'0')*100+i*10+(digits[3]-'0');
                    else if(weight==3)
                        temp1.i=(digits[0]-'0')*1000+(digits[1]-'0')*100+(digits[2]-'0')*10+i;

                    if(!visit[temp1.i] && isPrime[temp1.i])
                    {
                        temp1.step=temp.step+1;
                        visit[temp1.i]=true;
                        p_q.push(temp1);
                    }
                }
            }
        }
        while(!p_q.empty())
        {
            p_q.pop();
        }
        if(!isFind)
            printf("Impossible\n");
    }
    return 0;
}
posted on 2011-05-09 19:24  Eric-Yang  阅读(215)  评论(0编辑  收藏  举报